//BilderAufBreite_501d.js
// 11.09.2018 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Skalieren der ausgewhlten Rahmen

// die gewnschte Breite in Millimetern
fW = 175;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

// die Auswahl testen
selItems = app.selection;
nItems = selItems.length;
if (nItems == 0) {
	alert ("Es ist nichts ausgewhlt.", "Stop");
	exit();
}

// das aktuelle Dokument
var curDoc = app.documents[0];

// die Masseinheiten speichern
// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
ohM = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
if (ohM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.MILLIMETERS;
}

// eine Schleife durch die ausgewhlten Rahmen
var curSel;
var curType;
for (var n=0; n<nItems; n++) {
	curSel = selItems[n];
	curType = curSel.constructor.name;
	if (curType == "Rectangle") {
		scaleFrame(curSel);
	}
	else if (curType == "Image") {
		curSel = curSel.parent;
		scaleFrame(curSel);
	}
}

// Masseinheiten zurcksetzen (falls notwendig)
if (ohM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = ohM;
}

// die Auswahl aufheben
if (nItems > 1) {
	app.selection = null;
}

// die Funktion, welche den aktuellen Rahmen skaliert
function scaleFrame(curSel) {
	// die Abmessungen des Bildrahmens
	var gB = curSel.geometricBounds;
	// die aktuelle Breite ...
	var oldW = gB[3]-gB[1];
	// ... und die neue Bildgrsse errechnen
	var newPc = 100/(oldW/fW);
	// das aktuelle Bild
	var curImg = curSel.allGraphics[0];
	// den neuen Wert zuweisen
	curImg.properties = {horizontalScale:newPc, verticalScale:newPc};
	// den Rahmen anpassen
	curImg.fit(FitOptions.FRAME_TO_CONTENT);
}